package com.easefun.polyvsdk.po;

/**
 * 观众信息
 * @author Lionel 2019-3-5
 */
public class PolyvViewerInfo {
    private String viewerId = "";
    private String viewerName = "";
    private String viewerAvatar = "";

    public PolyvViewerInfo() {

    }

    /**
     * 设置观众信息
     * @param viewerId 观众ID
     * @param viewerName 观众昵称
     * @param viewerAvatar 观众头像
     */
    public PolyvViewerInfo(String viewerId, String viewerName, String viewerAvatar) {
        this.viewerId = viewerId;
        this.viewerName = viewerName;
        this.viewerAvatar = viewerAvatar;
    }

    /**
     * 获取观众ID
     * @return 观众ID
     */
    public String getViewerId() {
        return viewerId;
    }

    /**
     * 设置观众ID，默认值空字符串<br/>
     * 参数会用于两个地方<br/>
     * 第一会作为请求播放授权token时的参数-观众ID<br/>
     * 第二会作为观看日志的参数-自定义ID<br/>
     * @param viewerId 观众ID
     */
    public void setViewerId(String viewerId) {
        this.viewerId = viewerId;
    }

    /**
     * 获取观众昵称
     * @return 观众昵称
     */
    public String getViewerName() {
        return viewerName;
    }

    /**
     * 设置观众昵称，默认值空字符串
     * @param viewerName 观众昵称
     */
    public void setViewerName(String viewerName) {
        this.viewerName = viewerName;
    }

    /**
     * 获取观众头像图片的URL
     * @return 观众头像
     */
    public String getViewerAvatar() {
        return viewerAvatar;
    }

    /**
     * 设置观众头像图片的URL，默认值空字符串
     * @param viewerAvatar 观众头像
     */
    public void setViewerAvatar(String viewerAvatar) {
        this.viewerAvatar = viewerAvatar;
    }

    public void clean() {
        viewerId = "";
        viewerName = "";
        viewerAvatar = "";
    }
}
