package com.easefun.polyvsdk.srt;

import java.util.ArrayList;

/**
 * 字幕项VO
 * @author TanQu 2016-5-11
 */
public class PolyvSRTItemVO {
	public static final String SUBTITLE_CATEGORY_AN_TC = "{\\an8}";//tc->top_center
	private int count;
	private long start;
	private long end;
	private ArrayList<String> mSubLists = new ArrayList<String>();

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public long getStart() {
		return start;
	}

	public void setStart(long start) {
		this.start = start;
	}

	public long getEnd() {
		return end;
	}

	public void setEnd(long end) {
		this.end = end;
	}

	public ArrayList<String> getSubLists() {
		return mSubLists;
	}

	public void setSubLists(ArrayList<String> mSubLists) {
		this.mSubLists = mSubLists;
	}

	public boolean isTopCenterSubTitle() {
		for (String sub : mSubLists) {
			if (sub != null && sub.contains(SUBTITLE_CATEGORY_AN_TC)) {
				return true;
			}
		}
		return false;
	}

	public boolean isBottomCenterSubTitle() {
		return !isTopCenterSubTitle();
	}
	
	public String getSubTitle() {
		StringBuffer sb = new StringBuffer("");
		for (String sub : mSubLists) {
			if (sub != null) {
				sub = sub.replace(SUBTITLE_CATEGORY_AN_TC, "");
			}
			sb.append(sub).append("\n");
		}
		
		return sb.toString();
	}

}
