package com.easefun.polyvsdk.util;

import android.support.annotation.NonNull;

import com.easefun.polyvsdk.PolyvSDKClient;
import com.easefun.polyvsdk.database.videoProgress.VideoProgressDatabaseService;
import com.easefun.polyvsdk.vo.PolyvVideoProgressVO;


/**
 * 视频点播工具类
 * @author Lionel 2018-11-6
 */
public class PolyvVodPlayerUtil {
    /**
     * 获取视频观看进度，单位秒
     * @param vid 视频ID
     * @return 成功返回进度秒，失败返回0。
     */
    public static int lastPositionWithVid(@NonNull String vid) {
        return PolyvVideoProgressDatabaseUtil.getVideoProgress(vid) / 1000;
    }

    /**
     * 获取视频观看进度保存时间戳，单位毫秒
     * @param vid 视频ID
     * @return 成功返回毫秒时间戳，失败返回0。
     */
    public static long lastPositionTimestampWithVid(@NonNull String vid) {
        VideoProgressDatabaseService databaseService = PolyvSDKClient.getInstance().getVideoProgressService();
        if (databaseService == null) {
            return 0;
        }

        PolyvVideoProgressVO videoProgressVO = databaseService.getVideoProgress(vid);
        if (videoProgressVO == null) {
            return 0;
        }

        return videoProgressVO.getSaveTimeMillis();
    }
}
