package com.easefun.polyvsdk.video;

import com.easefun.polyvsdk.video.listener.IPolyvOnAdvertisementCountDownListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnAdvertisementEventListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnAdvertisementEventListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnAdvertisementOutListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnAdvertisementOutListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnBufferingUpdateListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnBufferingUpdateListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnChangeModeListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnCompletionListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnCompletionListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnErrorListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnErrorListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnExceptionCompletedListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnGestureClickListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnGestureDoubleClickListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnGestureLeftDownListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnGestureLeftUpListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnGestureRightDownListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnGestureRightUpListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnGestureSwipeLeftListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnGestureSwipeRightListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnGetVideoJsonTimeListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnInfoListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnInfoListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnPlayPauseListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnPreloadPlayListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnPreparedListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnPreparedListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnQuestionAnswerTipsListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnQuestionOutListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnQuestionOutListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnSeekCompleteListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnSeekCompleteListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnTeaserCountDownListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnTeaserOutListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnVideoPlayErrorListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnVideoPlayErrorListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnVideoSRTListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnVideoSRTPreparedListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnVideoSizeChangedListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnVideoSizeChangedListener2;
import com.easefun.polyvsdk.video.listener.IPolyvOnVideoStatusListener;
import com.easefun.polyvsdk.video.listener.IPolyvOnVideoTimeoutListener;

import tv.danmaku.ijk.media.player.IMediaPlayer;

/**
 * 监听事件设置接口
 * @author Lionel 2016-12-2
 */
public interface IPolyvVideoViewListenerEvent {
    /**
     * 设置视频缓存更新回调<br/>
     * 因为 {@link IPolyvOnBufferingUpdateListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnBufferingUpdateListener(IPolyvOnBufferingUpdateListener2)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnBufferingUpdateListener(IPolyvOnBufferingUpdateListener2)
     */
    @Deprecated
    void setOnBufferingUpdateListener(IPolyvOnBufferingUpdateListener l);

    /**
     * 设置视频缓存更新回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnBufferingUpdateListener(IPolyvOnBufferingUpdateListener2 l);

    /**
     * 设置视频播放/暂停/播放完成回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnPlayPauseListener(IPolyvOnPlayPauseListener l);

    /**
     * 设置预加载播放回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnPreloadPlayListener(IPolyvOnPreloadPlayListener l);

    /**
     * 设置视频非播放器内部错误回调
     * @see #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener)
     * @param l 设置为null就是清除监听回调
     */
    @Deprecated
    void setOnVideoPlayErrorLisener(IPolyvOnVideoPlayErrorListener l);

    /**
     * 设置视频非播放器内部错误回调
     * @see #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2)
     * @param l 设置为null就是清除监听回调
     */
    @Deprecated
    void setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener l);

    /**
     * 设置视频非播放器内部错误回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2 l);

    /**
     * 设置视频状态回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnVideoStatusListener(IPolyvOnVideoStatusListener l);

    /**
     * 设置视频播放完成回调<br/>
     * 因为 {@link IPolyvOnCompletionListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnCompletionListener(IPolyvOnCompletionListener2)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnCompletionListener(IPolyvOnCompletionListener2)
     */
    @Deprecated
    void setOnCompletionListener(IPolyvOnCompletionListener l);

    /**
     * 设置视频播放完成回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnCompletionListener(IPolyvOnCompletionListener2 l);

    /**
     * 设置视频已准备好马上进入播放回调<br/>
     * 因为 {@link IPolyvOnPreparedListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnPreparedListener(IPolyvOnPreparedListener2)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnPreparedListener(IPolyvOnPreparedListener2)
     */
    @Deprecated
    void setOnPreparedListener(IPolyvOnPreparedListener l);

    /**
     * 设置视频已准备好马上进入播放回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnPreparedListener(IPolyvOnPreparedListener2 l);

    /**
     * 设置视频播放器内部错误回调<br/>
     * 因为 {@link IPolyvOnErrorListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnErrorListener(IPolyvOnErrorListener2)}。
     * 为了能更好的统一错误处理，这个错误回调合并到{@link #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2)}中，对应的错误类型是{@link PolyvPlayErrorReason#VIDEO_ERROR}。
     * 为了向后兼容，以前的程序不受影响，当设置了这个错误回调时，{@link #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2)}错误回调不会被触发。
     * 没有设置这个错误回调时，{@link #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2)}错误回调才会触发。
     * @param l 设置为null就是清除监听回调
     * @see #setOnErrorListener(IPolyvOnErrorListener2)
     * @see #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2)
     */
    @Deprecated
    void setOnErrorListener(IPolyvOnErrorListener l);

    /**
     * 设置视频播放器内部错误回调<br/>
     * 为了能更好的统一错误处理，这个错误回调合并到{@link #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2)}中，对应的错误类型是{@link PolyvPlayErrorReason#VIDEO_ERROR}。
     * 为了向后兼容，以前的程序不受影响，当设置了这个错误回调时，{@link #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2)}错误回调不会被触发。
     * 没有设置这个错误回调时，{@link #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2)}错误回调才会触发。
     * @param l 设置为null就是清除监听回调
     * @see #setOnVideoPlayErrorListener(IPolyvOnVideoPlayErrorListener2)
     */
    @Deprecated
    void setOnErrorListener(IPolyvOnErrorListener2 l);

    /**
     * 设置视频播放器信息有变更回调<br/>
     * 因为 {@link IPolyvOnInfoListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnInfoListener(IPolyvOnInfoListener2)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnInfoListener(IPolyvOnInfoListener2)
     */
    @Deprecated
    void setOnInfoListener(IPolyvOnInfoListener l);

    /**
     * 设置视频播放器信息有变更回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnInfoListener(IPolyvOnInfoListener2 l);

    /**
     * 设置seek完成回调<br/>
     * 因为 {@link IPolyvOnSeekCompleteListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnSeekCompleteListener(IPolyvOnSeekCompleteListener2)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnSeekCompleteListener(IPolyvOnSeekCompleteListener2)
     */
    @Deprecated
    void setOnSeekCompleteListener(IPolyvOnSeekCompleteListener l);

    /**
     * 设置seek完成回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnSeekCompleteListener(IPolyvOnSeekCompleteListener2 l);

    /**
     * 设置视频尺寸改变回调<br/>
     * 因为 {@link IPolyvOnVideoSizeChangedListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnVideoSizeChangedListener(IPolyvOnVideoSizeChangedListener2)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnVideoSizeChangedListener(IPolyvOnVideoSizeChangedListener2)
     */
    @Deprecated
    void setOnVideoSizeChangedListener(IPolyvOnVideoSizeChangedListener l);

    /**
     * 设置视频尺寸改变回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnVideoSizeChangedListener(IPolyvOnVideoSizeChangedListener2 l);

    /**
     * 设置广告弹出监听回调
     * @param l 设置为null就是清除监听回调
     * @see #setOnAdvertisementOutListener(IPolyvOnAdvertisementOutListener2)
     */
    @Deprecated
    void setOnAdvertisementOutListener(IPolyvOnAdvertisementOutListener l);

    /**
     * 设置广告弹出监听回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnAdvertisementOutListener(IPolyvOnAdvertisementOutListener2 l);

    /**
     * 设置广告倒计时监听回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnAdvertisementCountDownListener(IPolyvOnAdvertisementCountDownListener l);

    /**
     * 设置视频广告显示/点击监听回调
     * @param l 设置为null就是清除监听回调
     * @see #setOnAdvertisementEventListener(IPolyvOnAdvertisementEventListener2)
     */
    @Deprecated
    void setOnAdvertisementEventListener(IPolyvOnAdvertisementEventListener l);

    /**
     * 设置视频广告显示/点击监听回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnAdvertisementEventListener(IPolyvOnAdvertisementEventListener2 l);

    /**
     * 设置片头弹出监听回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnTeaserOutListener(IPolyvOnTeaserOutListener l);

    /**
     * 设置片头倒计时监听回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnTeaserCountDownListener(IPolyvOnTeaserCountDownListener l);

    /**
     * 设置问答弹出监听回调，告诉此时应该弹出问答
     * @param l 设置为null就是清除监听回调
     * @see #setOnQuestionOutListener(IPolyvOnQuestionOutListener2)
     */
    @Deprecated
    void setOnQuestionOutListener(IPolyvOnQuestionOutListener l);

    /**
     * 设置问答弹出监听回调，告诉此时应该弹出问答
     * @param l 设置为null就是清除监听回调
     */
    void setOnQuestionOutListener(IPolyvOnQuestionOutListener2 l);

    /**
     * 设置问答答错提示监听回调，告诉此时应该弹出提示
     * @param l 设置为null就是清除监听回调
     */
    void setOnQuestionAnswerTipsListener(IPolyvOnQuestionAnswerTipsListener l);

    /**
     * 设置字幕监听回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnVideoSRTListener(IPolyvOnVideoSRTListener l);

    /**
     * 设置字幕准备完成监听回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnVideoSRTPreparedListener(IPolyvOnVideoSRTPreparedListener l);

    /**
     * 设置手势左向上回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnGestureLeftUpListener(IPolyvOnGestureLeftUpListener l);

    /**
     * 设置手势左向下回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnGestureLeftDownListener(IPolyvOnGestureLeftDownListener l);

    /**
     * 设置手势右向上回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnGestureRightUpListener(IPolyvOnGestureRightUpListener l);

    /**
     * 设置手势右向下回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnGestureRightDownListener(IPolyvOnGestureRightDownListener l);

    /**
     * 设置手势左滑回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnGestureSwipeLeftListener(IPolyvOnGestureSwipeLeftListener l);

    /**
     * 设置手势右滑回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnGestureSwipeRightListener(IPolyvOnGestureSwipeRightListener l);

    /**
     * 设置手势单击回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnGestureClickListener(IPolyvOnGestureClickListener l);

    /**
     * 设置手势双击回调
     * @param l 设置为null就是清除监听回调
     */
    void setOnGestureDoubleClickListener(IPolyvOnGestureDoubleClickListener l);

    /**
     * 设置视频播放完成回调<br/>
     * 因为 {@link IMediaPlayer.OnCompletionListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnCompletionListener(IPolyvOnCompletionListener)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnCompletionListener(IPolyvOnCompletionListener)
     */
    @Deprecated
    void setOnCompletionListener(IMediaPlayer.OnCompletionListener l);
    /**
     * 设置视频播放器内部错误回调<br/>
     * 因为 {@link IMediaPlayer.OnErrorListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnErrorListener(IPolyvOnErrorListener)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnErrorListener(IPolyvOnErrorListener)
     */
    @Deprecated
    void setOnErrorListener(IMediaPlayer.OnErrorListener l);
    /**
     * 设置视频播放器信息有变更回调<br/>
     * 因为 {@link IMediaPlayer.OnInfoListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnInfoListener(IPolyvOnInfoListener)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnInfoListener(IPolyvOnInfoListener)
     */
    @Deprecated
    void setOnInfoListener(IMediaPlayer.OnInfoListener l);
    /**
     * 设置视频已准备好马上进入播放回调<br/>
     * 因为 {@link IMediaPlayer.OnPreparedListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnPreparedListener(IPolyvOnPreparedListener)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnPreparedListener(IPolyvOnPreparedListener)
     */
    @Deprecated
    void setOnPreparedListener(IMediaPlayer.OnPreparedListener l);
    /**
     * 设置视频缓存更新回调<br/>
     * 因为 {@link IMediaPlayer.OnBufferingUpdateListener} 回调方法中第一个参数对于外部并没有提供什么帮助，避免造成多余困扰，请使用 {@link #setOnBufferingUpdateListener(IPolyvOnBufferingUpdateListener)}
     * @param l 设置为null就是清除监听回调
     * @see #setOnBufferingUpdateListener(IPolyvOnBufferingUpdateListener)
     */
    @Deprecated
    void setOnBufferingUpdateListener(IMediaPlayer.OnBufferingUpdateListener l);
    /**
     * 设置改变播放模式监听器
     * @param l 设置为null就是清除监听回调
     */
    void setOnChangeModeListener(IPolyvOnChangeModeListener l);

    /**
     * 设置视频加载/缓冲超时的监听器
     * @param l 设置为null就是清除监听回调
     */
    void setOnVideoTimeoutListener(IPolyvOnVideoTimeoutListener l);

    /**
     * 设置异常完成监听器
     * @param l
     */
    void setOnExceptionCompletedListener(IPolyvOnExceptionCompletedListener l);

    /**
     * 设置获取videojson时间、超时监听器
     * @param l
     */
    void setOnGetVideoJsonTimeListener(IPolyvOnGetVideoJsonTimeListener l);
}
