package com.easefun.polyvsdk.video;

import android.support.annotation.IntDef;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * 播放策略类型
 * @author Lion 2017-12-14
 */
public class PolyvPlayStrategy {
    /** 播放策略模式，有本地缓存的视频文件就播放本地缓存的视频文件，没有本地缓存的视频文件就播放网络视频。默认。 */
    public static final int DEFAULT = 1;
    /** 网络播放模式，去播放网络视频，会忽略本地缓存的视频文件。 */
    public static final int NET_PLAY = 2;
    /** 本地播放模式，去播放本地视频。 */
    public static final int LOCAL_PLAY = 3;


    /** @hide */
    @IntDef({
            DEFAULT,
            NET_PLAY,
            LOCAL_PLAY
    })
    @Retention(RetentionPolicy.SOURCE)
    public @interface PlayStrategy {}
}
